/*Generated Structures by Arjay07*/
/*Uses*/
/*StructureJS 2.0*/
/*By Arjay07*/

var IO = java.io;
var File = IO.File;
var FileReader = IO.FileReader;
var BufferedReader = IO.BufferedReader;
var String = java.lang.String;
var StringBuilder = java.lang.StringBuilder;

function readFile(file){

var str;
var br = new BufferedReader(new FileReader(file));
var data = new StringBuilder();

while((str = br.readLine()) != null){

data.append(str);
data.append("\n");

}

return data.toString();

}

function Vertex(x, y, z){

this.x = x;
this.y = y;
this.z = z;

}

function Structure(file){

var structure = readFile(file);
var line = structure.split("\n");
var v = [];
var id = [];
var dmg = [];

for(var i = 0; i < line.length; i++){

var param = line[i].split(":");
var coord = param[0].split("~");
var block = param[1].split(";");
var x = parseInt(coord[0]);
var y = parseInt(coord[1]);
var z = parseInt(coord[2]);
var b = parseInt(block[0]);
var d = parseInt(block[1]);

v.push(new Vertex(x, y, z));
id.push(b);
dmg.push(d==null?0:d);

}

this.positions = v;
this.blockIds = id;
this.damages = dmg;

}

function setStructure(structure, x, y, z)
{

var s = structure.positions;
var id = structure.blockIds;
var d = structure.damages;

for(var i = 0; i < s.length; i++){

var p = s[i];
var bId = id[i];
var bDmg = d[i]; 

setTile(x+p.x, y+p.y, z+p.z, bId, bDmg);

}

}

//////////////////////////////////
/**********COPY TO HERE**********/
//////////////////////////////////

function getSurface(x, z){

var i = 0;

for(var y = 1; y <= 128; y++){

if(Level.getTile(x, y, z) == 0){

i = y;
break;

}

}

return i;

}

function random(min, max){

return Math.floor((Math.random()*max)+min);

}

var SDCARD = android.os.Environment.getExternalStorageDirectory();
var granitefile = new File(SDCARD,"granite_vein.xtr");
var granite = new Structure(granitefile);
var dioritefile = new File(SDCARD,"diorite_vein.xtr");
var diorite = new Structure(dioritefile);
var andesitefile = new File(SDCARD,"andesite_vein.xtr");
var andesite = new Structure(andesitefile);
var quartzorefile = new File(SDCARD, "quartzore.xtr");
var quartzore = new Structure(quartzorefile);

function spawnStructures(){
//1000 ores
for(var i = 0; i <=125 ; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(quartzore, x, getSurface(x, z) - 20, z);

}
for(var i = 0; i <=50 ; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(granite, x, getSurface(x, z) - 10, z);

}
for(var i = 0; i <=50 ; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(diorite, x, getSurface(x, z) - 10, z);

}
for(var i = 0; i <=50 ; i++){

var x = random(0, 256);
var z = random(0, 256);

setStructure(andesite, x, getSurface(x, z) - 10, z);

}

}


function newLevel(){

var spawned = new File(SDCARD + "/games/com.mojang/minecraftWorlds/" + Level.getWorldDir(), "spawned.txt");

if(!spawned.exists()){

spawnStructures();

try{

spawned.createNewFile();

}catch(e){

print(e);

}

}

}